<#macro getQuickSearchPlaceholder view>
  <#assign isdrawcComma = false />
  <#if view?? && view.getPSAppDataEntity?? && view.getPSAppDataEntity()?? && view.getPSAppDataEntity().getAllPSAppDEFields?? && view.getPSAppDataEntity().getAllPSAppDEFields()??>
    <#list view.getPSAppDataEntity().getAllPSAppDEFields() as field>
      <#if field.isEnableQuickSearch()>
        <#if isdrawcComma>，<#else><#assign isdrawcComma = true /></#if><#t>
        ${field.getPSDEField().getLogicName()}<#t>
      </#if>
    </#list>
  </#if>
</#macro>
<#-- 按类型绘制 -->
<#macro renderByDetailType panelDetail view isMultiData>
    <#if panelDetail.getItemType()?? && panelDetail.getItemType() == "CONTAINER">
    <#-- 边缘布局 -->
    <#if panelDetail.getPSLayout().getLayout()?? && panelDetail.getPSLayout().getLayout() == "BORDER" >
    <app-scroll-container name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails">
    <#if panelDetail.getPSPanelItems()??>
        <#list panelDetail.getPSPanelItems() as panelItem>
        <template #${panelItem.getName()}>
        <@renderByDetailType panelItem view isMultiData />
        </template>
        </#list>
    </#if>
    </app-scroll-container>
    <#-- SIMPLEFLEX布局(栅格布局) -->
    <#elseif panelDetail.getPSLayout().getLayout()?? && panelDetail.getPSLayout().getLayout() == "SIMPLEFLEX" >
    <app-simpleflex-container name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails">
     <#if panelDetail.getPSPanelItems()??>
        <#list panelDetail.getPSPanelItems() as panelItem>
        <template #${panelItem.getName()}>
        <@renderByDetailType panelItem view isMultiData />
        </template>
        </#list>
    </#if>
    </app-simpleflex-container>
    <#else>
    <#assign isTempMultiData = isMultiData />
    <#assign iscurMultiData = false />
    <#if panelDetail.getDataRegionType?? && panelDetail.getDataRegionType()?? && panelDetail.getDataRegionType()=="MULTIDATA">
    <#assign isTempMultiData = true />
     <#assign iscurMultiData = true />
    </#if>
    <app-standard-container name="${panelDetail.getName()}"<#if (isTempMultiData == true) && (iscurMultiData == false) > :index="slotProps.data.index"</#if> :isMultiContainer="${iscurMultiData?c}" :layoutModelDetails="layoutModelDetails">
     <#if panelDetail.getPSPanelItems()??>
        <#list panelDetail.getPSPanelItems() as panelItem>
        <template <#if iscurMultiData == true>v-slot:${panelItem.getName()}="slotProps"<#else>#${panelItem.getName()}</#if>>
        <@renderByDetailType panelItem view isTempMultiData/>
        </template>
        </#list>
    </#if>
    </app-standard-container>
    </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "TABPAGE">
    <app-tab-page name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">
        <#if panelDetail.getPSPanelItems?? && panelDetail.getPSPanelItems()??>
            <#list panelDetail.getPSPanelItems() as panelItem>
        <template #${panelItem.getName()}>
            <@renderByDetailType panelItem view isMultiData />
        </template>
            </#list>
        </#if>
    </app-tab-page>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "TABPANEL">
    <app-tab-panel name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">
        <#if panelDetail.getPSPanelTabPages?? && panelDetail.getPSPanelTabPages()??>
            <#list panelDetail.getPSPanelTabPages() as tabPage>
        <template #${tabPage.getName()}>
            <@renderByDetailType tabPage view isMultiData/>
        </template>
            </#list>
        </#if>
    </app-tab-panel>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "FIELD">
        <#if panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_USERID">
        <@compress  single_line=true><app-login-input 
            class="app-login-user"  
            name="${panelDetail.getName()}" 
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if>
            defaultIcon="ios-contact" 
            @valueChange="handleValueChange" /></@compress>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_PASSWORD">
        <@compress  single_line=true><app-login-input
            class="app-login-password" 
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            defaultType="password"
            :layoutModelDetails="layoutModelDetails"
            :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if>
            defaultIcon="ios-key"
            @valueChange="handleValueChange" /></@compress>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_ORGPICK">
        <@compress  single_line=true><app-login-org 
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if> 
            :layoutModelDetails="layoutModelDetails" 
            :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if>
            @valueChange="handleValueChange" /></@compress>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_VERIFICATIONCODE">
        <@compress  single_line=true><app-login-note-verify 
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if>
            @valueChange="handleValueChange" /></@compress>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_LOGINMSG">
        <@compress  single_line=true><app-login-message 
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if> /></@compress>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "APP_APPTITLE">
        <@compress  single_line=true><app-preset-title
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"/></@compress>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "VIEW_PAGECAPTION">
        <@compress  single_line=true><app-preset-caption
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails">
            ${view.caption}
            </app-preset-caption></@compress>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_TEXT_DYNAMIC">
        <@compress  single_line=true><app-preset-text
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if>
            :layoutModelDetails="layoutModelDetails"/></@compress>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_SWITCH">
        <@compress  single_line=true><app-preset-switch 
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if>
            @valueChange="handleValueChange"/></@compress>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_QRCODE">
        <@compress  single_line=true><app-preset-qrcode
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if> /></@compress>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_ORGPICK">
        <@compress  single_line=true><app-index-org-select
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"/></@compress>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_IMAGE">
        <@compress  single_line=true><app-field-image-dynamic
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if>
            :layoutModelDetails="layoutModelDetails" /></@compress>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_CAROUSEL">
        <@compress  single_line=true><app-rawitem-carousel 
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if> 
            type="FIELD_CAROUSEL"
            :data="layoutData"
            :layoutModelDetails="layoutModelDetails"/></@compress>
        <#else>
        <@compress  single_line=true><app-panel-field
                name="${panelDetail.getName()}"
                <#if isMultiData == true >:index="slotProps.data.index"</#if>
                :data="layoutData"
                :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if>>
                <#if panelDetail.getPSEditor?? && panelDetail.getPSEditor()??>
                    <#if panelDetail.getPSEditor().getEditorType() == 'DROPDOWNLIST'>
                    <dropdown-list 
                        :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if> 
                        :data="layoutData" 
                        :context="context"
                        :viewparams="viewparams"
                        :formState="viewState" 
                        :disabled="layoutModelDetails.${panelDetail.name}.disabled"
                        :localContext=<@getNavigateContext panelDetail />
                        :localParam=<@getNavigateParams panelDetail />
                        <#if panelDetail.getPSCodeList()??>
                        <#assign codelist=panelDetail.getPSCodeList()>
                        tag="${codelist.codeName}"
                        codelistType="${codelist.getCodeListType()}"
                        </#if> 
                        placeholder=<#if panelDetail.getPlaceHolder()??>'${panelDetail.getPlaceHolder()}'<#else>'请选择...'</#if> 
                        @change="(value) => handleValueChange({ name: '${panelDetail.name}', value})">
                    </dropdown-list>
                    <#elseif panelDetail.getPSEditor().getEditorType() == 'NUMBER'>
                    <input-box 
                        type="number" 
                        :precision="2"
                        :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if>  
                        :disabled="layoutModelDetails.${panelDetail.name}.disabled" 
                        <#if panelDetail.getUnitName?? && panelDetail.getUnitName()??>unit="${panelDetail.getUnitName()}"</#if>
                        <#if panelDetail.getPlaceHolder()??>placeholder="${panelDetail.getPlaceHolder()}"</#if> 
                        @change="(value) => handleValueChange({ name: '${panelDetail.name}', value})">
                    </input-box>
                    <#elseif panelDetail.getPSEditor().getEditorType() == 'PASSWORD'>
                    <input-box 
                        type="password"
                        name="${panelDetail.name}"
                        :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if> 
                        :disabled="layoutModelDetails.${panelDetail.name}.disabled"
                        <#if panelDetail.getPlaceHolder()??>placeholder="${panelDetail.getPlaceHolder()}"</#if>
                        @change="(value) => handleValueChange({ name: '${panelDetail.name}', value})">
                    </input-box>
                    <#else>
                    <app-preset-text-input
                        name="${panelDetail.getName()}"
                        <#if isMultiData == true >:index="slotProps.data.index"</#if>
                        :layoutModelDetails="layoutModelDetails"
                        :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if>
                        @valueChange="handleValueChange"/>
                    </#if>
                <#else>
                <app-preset-text-input
                    name="${panelDetail.getName()}"
                    <#if isMultiData == true >:index="slotProps.data.index"</#if>
                    :layoutModelDetails="layoutModelDetails"
                    :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if>
                    @valueChange="handleValueChange"/>
                </#if>
            </app-panel-field></@compress>
        </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "RAWITEM">
        <#if panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()??>
        <#assign rawdetail = panelDetail.getPSRawItem()/>
        <#if  rawdetail.getPredefinedType?? && rawdetail.getPredefinedType()?? && rawdetail.getPredefinedType() == "STATIC_IMAGE">
        <@compress  single_line=true><app-rawitem-image
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            <#if rawdetail.getPSSysImage?? && rawdetail.getPSSysImage()?? && rawdetail.getPSSysImage().getImagePath?? && rawdetail.getPSSysImage().getImagePath()??>
            imgUrl="${ rawdetail.getPSSysImage().getImagePath() }"
            </#if>
            <#if rawdetail.getPSSysImage?? && rawdetail.getPSSysImage()?? && rawdetail.getPSSysImage().getCssClass?? && rawdetail.getPSSysImage().getCssClass()??>
            imageClass="${ rawdetail.getPSSysImage().getCssClass() }"
            </#if>
            :layoutModelDetails="layoutModelDetails"/></@compress>
        <#elseif rawdetail.getPredefinedType?? && rawdetail.getPredefinedType()?? && rawdetail.getPredefinedType() == "STATIC_CAROUSEL">
        <@compress  single_line=true><app-rawitem-carousel
            name="${panelDetail.getName()}"
            type="STATIC_CAROUSEL"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :value="[
            <#if rawdetail.getPSRawItemParams?? && rawdetail.getPSRawItemParams()??>
            <#list rawdetail.getPSRawItemParams() as param>{                
                 <#if param.key??>
                    key:'${param.key}',
                </#if>
                 <#if param.value??>
                    value:'${param.value}',
                <#elseif param.getPSSysImage?? && param.getPSSysImage()?? && param.getPSSysImage().getImagePath?? && param.getPSSysImage().getImagePath()?? && param.getPSSysImage().getImagePath?? && param.getPSSysImage().getImagePath() != "">
                    imgPath:'${param.getPSSysImage().getImagePath()}',
                    type:'img'
                 <#elseif param.getPSSysImage?? && param.getPSSysImage()?? && param.getPSSysImage().getCssClass?? && param.getPSSysImage().getCssClass()??>
                    iconClass:'${param.getPSSysImage().getCssClass()}',
                    type:'icon'
                </#if> 
                }<#if param_has_next>,</#if>              
            </#list>
            </#if>
            ]"
            :layoutModelDetails="layoutModelDetails"
            :data="layoutData"/></@compress>
        <#elseif rawdetail.getPredefinedType?? && rawdetail.getPredefinedType()?? && rawdetail.getPredefinedType() == "STATIC_VIDEOPLAYER">
        <@compress  single_line=true><app-rawitem-video 
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            :videoParmas="[
            <#if rawdetail.getPSRawItemParams?? && rawdetail.getPSRawItemParams()??>
            <#list rawdetail.getPSRawItemParams() as param>{                
                 <#if param.key??>
                    key:'${param.key}',
                </#if>
                 <#if param.value??>
                    value:'${param.value}',
                </#if> 
                }<#if param_has_next>,</#if>              
            </#list>
            </#if>
            ]"/></@compress>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && panelDetail.getPSRawItem().getPredefinedType() == 'NAV_POS'>
        <@compress  single_line=true><app-nav-pos 
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            :navData="layoutModelDetails['${panelDetail.getName()}'].navData"/></@compress>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && panelDetail.getPSRawItem().getPredefinedType() == 'NAV_BREADCRUMB'>
        <@compress  single_line=true><app-index-nav-breadcrumb 
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            <#if view?? && view.getViewType?? && view.getViewType() == 'APPINDEXVIEW'> indexViewTag="${srffilepath2(view.getCodeName())}"</#if> /></@compress>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && (panelDetail.getPSRawItem().getPredefinedType() == 'STATIC_LABEL' || panelDetail.getPSRawItem().getPredefinedType() == 'STATIC_TEXT')>
        <@compress  single_line=true><app-preset-text 
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"/></@compress>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && panelDetail.getPSRawItem().getPredefinedType() == 'NAV_TABS'>
        <@compress  single_line=true><app-index-nav-tabs
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails" /></@compress>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && panelDetail.getPSRawItem().getPredefinedType() == 'AUTH_USERINFO'>
        <@compress  single_line=true><app-index-user-info
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails" /></@compress>
        </#if>
     </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "BUTTON">
        <#if panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()?? && panelDetail.getPSUIAction().getPredefinedType?? && panelDetail.getPSUIAction().getPredefinedType()?? && panelDetail.getPSUIAction().getPredefinedType() == "APP_LOGIN">
        <@compress  single_line=true><app-login-button
            class="app-login-button"
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            defaultStyle='primary'
            @itemClick="handleButtonClick" /></@compress>
        <#elseif panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()?? && panelDetail.getPSUIAction().getPredefinedType?? && panelDetail.getPSUIAction().getPredefinedType()?? && panelDetail.getPSUIAction().getPredefinedType() == "DATA_CANCELCHANGES">
        <@compress  single_line=true><app-login-button
            class="app-reset-button" 
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if> 
            :layoutModelDetails="layoutModelDetails"
            defaultStyle='success'
            @itemClick="handleButtonClick" /></@compress>
        <#elseif panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()?? && panelDetail.getPSUIAction().getPredefinedType?? && panelDetail.getPSUIAction().getPredefinedType()?? && panelDetail.getPSUIAction().getPredefinedType() == "APP_LOGOUT">
        <@compress  single_line=true><app-login-button
            class="app-logout-button"
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            @itemClick="handleButtonClick" /></@compress>
        <#elseif panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()??>
        <@compress  single_line=true><app-preset-button
            name="${panelDetail.getName()}" 
            <#if isMultiData == true > :index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            <#if panelDetail.getCaptionItemName?? && panelDetail.getCaptionItemName() != ''>
            :caption="layoutData.${panelDetail.getCaptionItemName()}"
            :tooltip="layoutData.${panelDetail.getCaptionItemName()}"
            <#else>
            caption="${panelDetail.getPSUIAction().getCaption()}"
            tooltip="${panelDetail.getPSUIAction().getTooltip()}"
            </#if>
            @itemClick="handleButtonClick" /></@compress>
        <#else>
        <@compress  single_line=true><app-preset-button
            name="${panelDetail.getName()}" 
            <#if isMultiData == true > :index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            caption="${panelDetail.getCaption()}"
            @itemClick="handleButtonClick"/></@compress>
        </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "CTRLPOS">
        <app-ctrl-pos name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails">
        <#if panelDetail.getName() == 'quicksearchbar' || panelDetail.getName() == 'QUICKSEARCHBAR'>
        <i-input v-model="query" search enter-button @on-search="onSearch($event)" class='quick-search-input' style='max-width: 400px;' placeholder="<@getQuickSearchPlaceholder view />" />
        <#elseif view?? && view.hasPSControl?? && view.hasPSControl(panelDetail.getName())>
        ${P.getCtrlCode(panelDetail.getName(), 'CONTROL.html').code}
        <#else>
                <span>部件占位${panelDetail.getName()}</span>
        </#if>
        </app-ctrl-pos>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "USERCONTROL">
        <#if panelDetail.getPredefinedType?? && panelDetail.getPredefinedType()?? && panelDetail.getPredefinedType() == "AUTH_CAPTCHA">
        <@compress  single_line=true><app-login-captcha
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if>
            @valueChange="handleValueChange" /></@compress>
        <#elseif panelDetail.getPredefinedType?? && panelDetail.getPredefinedType()?? && panelDetail.getPredefinedType() == "AUTH_SSO">
        <@compress  single_line=true><app-login-third 
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if> 
            :layoutModelDetails="layoutModelDetails" 
            :value=<#if isMultiData == true >"layoutData[`${panelDetail.getName()}_<#noparse>${slotProps.data.index}</#noparse>`]"<#else>"layoutData.${panelDetail.getName()}"</#if> /></@compress>
        <#else>
        <@compress  single_line=true><span>用户自定义控件</span></@compress>
        </#if>
    <#else>
    <@compress  single_line=true><span>${panelDetail.getItemType()}暂未支持</span></@compress>
    </#if>
</#macro>